//+------------------------------------------------------------------+
//|                                           RSI color separate.mq4 |
//|                                                            Gyfto |
//|                                        " " |
//+------------------------------------------------------------------+
#property indicator_separate_window
extern int periodRSI=14;
extern bool image=true;// ,     
extern double focus=1.8;
//     ,    .   -  .
extern double Staturation=1.0;// 
extern double Lightness=0.5;// 
double ExtMapBuffer1[];
double ExtMapBuffer2[];
bool b=true;
bool up=true;
double Hue;

int init()
  {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   focus=MathAbs(focus); if (focus<0.1) focus=0.1; if (focus>10) focus=10;//   (  )     
   return(0);
  }

int deinit()
  {
   ObjectsDeleteAll(WindowOnDropped(), OBJ_HLINE);
   return(0);
  }

int start()
  {
//    .    init(),   WindowOnDropped()    start()
   if(image){
      if(b){
         for(int i=0; i<=100; i++){
            double x=i; x/=100;
            double hue=SpectralFilter(x, focus);
            color RGB=HSLtoRGB(hue, Staturation, Lightness);
            string name=DoubleToStr(hue,8);
            ObjectCreate(name,OBJ_HLINE,WindowOnDropped(),0,hue);
            ObjectSet(name, OBJPROP_COLOR, RGB);
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            ObjectSet(name, OBJPROP_WIDTH, 1);
         }
         b=false;
      }
   }else{
      ObjectsDeleteAll(WindowOnDropped(),OBJ_HLINE);
   }//     0.3  0.7
   hue=SpectralFilter(0.3,focus); ObjectCreate("alert 0.3", OBJ_HLINE, WindowOnDropped(), 0, hue);
   hue=SpectralFilter(0.7,focus); ObjectCreate("alert 0.7", OBJ_HLINE, WindowOnDropped(), 0, hue);
   ObjectSet("alert 0.3", OBJPROP_COLOR, Silver); ObjectSet("alert 0.7", OBJPROP_COLOR, Silver);
   ObjectSet("alert 0.3", OBJPROP_STYLE, STYLE_SOLID); ObjectSet("alert 0.7", OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet("alert 0.3", OBJPROP_WIDTH, 2); ObjectSet("alert 0.7", OBJPROP_WIDTH, 2);
   //     -  . :    ,   
   RGB = HSLtoRGB(Hue/256, 1.0, 0.5);
   SetIndexStyle(0, DRAW_LINE, EMPTY, EMPTY, RGB);
   if(up) Hue++; else Hue--;
   if((Hue==255.0)||(Hue==0.0)) up=!up;
   int counted_bars=IndicatorCounted();//     
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   for(i=0; i<limit; i++){
      double variable=iRSI(NULL, 0, periodRSI, PRICE_CLOSE, i);
      variable/=100;//   0  +100    0  +1
      variable=SpectralFilter(variable, focus);//    
      ExtMapBuffer1[i]=variable;
   }   
   return(0);
  }

double Hue_To_RGB(double P,double Q,double Tc){
	if(Tc<0) Tc+=1.0;
	if(Tc>1.0) Tc-=1.0;
	if(Tc<1.0/6.0) return(P+(Q-P)*6.0*Tc);
	if(Tc<1.0/2.0) return(Q);
	if(Tc<2.0/3.0) return(P+(Q-P)*((2.0/3.0)-Tc)*6.0);
	return(P);
}

color HSLtoRGB(double aH,double aS,double aL){
	if(aS==0){
		double oR=aL*255;
		double oG=aL*255;
		double oB=aL*255;
	}else{
		double Q;
		if(aL<0.5) Q=aL*(1.0+aS); else Q=(aL+aS)-(aS*aL);
		double P=2.0*aL-Q;
		oR=255.0*Hue_To_RGB(P,Q,aH+(1.0/3.0));
		oG=255.0*Hue_To_RGB(P,Q,aH);
		oB=255.0*Hue_To_RGB(P,Q,aH-(1.0/3.0));
	}
	return(0x100*0x100*DoubleToInt(oB)+0x100*DoubleToInt(oG)+DoubleToInt(oR));
}
int DoubleToInt(double var){return(var);}

double SpectralFilter(double var, double focus){
   if (var<0.5) var=MathPow((MathPow(0.5,focus)-MathPow(MathAbs(var-0.5),focus)),1/focus);
   else var=1-MathPow((MathPow(0.5,focus)-MathPow(MathAbs(var-0.5),focus)),1/focus);
   return(var);
}